"use strict";

function isTouchEnabled() {
    return (('ontouchstart' in window)
        || (navigator.MaxTouchPoints > 0)
        || (navigator.msMaxTouchPoints > 0));
}

(function ($) {
    $(document).ready(function () {
        $("path[id^=\"uscanadamapvt_\"]").each(function (i, e) {
            addEvent($(e).attr('id'));
        });
    });

    function addEvent(id, relationId) {
        var _obj = $('#' + id);
        var _abb = id.split('');
        var _Textobj = $('#' + id + ',' + '#uscanadavnvt_' + _abb.slice(14).join(''));
        var _h = $('#map').height();

        $('#' + ['uscanadavisns-t']).attr({'fill': uscanada_map_t_config['default']['uscanadavisns_t']});
        $('#uscanadalakes-t').css({'fill': uscanada_map_t_config['default']['uscanadalakesfill_t']});
        $('#uscanadalakes-t path').css({'stroke': uscanada_map_t_config['default']['uscanadalakesout_t']});
        $('#uscanadamapwrapper-t').css({'opacity': '1'});

        _obj.attr({'fill': uscanada_map_t_config[id]['upclr'], 'stroke': uscanada_map_t_config['default']['uscanadabrdrclr_t']});
        _Textobj.attr({'cursor': 'default'});
        if (uscanada_map_t_config[id]['enbl'] === true) {
            if (isTouchEnabled()) {
                var touchmoved;
                _Textobj.on('touchend', function (e) {
                    if (touchmoved !== true) {
                        _Textobj.on('touchstart', function (e) {
                            let touch = e.originalEvent.touches[0];
                            let x = touch.pageX - 10, y = touch.pageY + (-15);

                            let $mtip = $('#tipuscanadamap-t');
                            let maptipw = $mtip.outerWidth(),
                                maptiph = $mtip.outerHeight();

                            x = (x + maptipw > $(document).scrollLeft() + $(window).width()) ? x - maptipw - (20 * 2) : x
                            y = (y + maptiph > $(document).scrollTop() + $(window).height()) ? $(document).scrollTop() + $(window).height() - maptiph - 10 : y

                            if (uscanada_map_t_config[id]['targt'] !== 'none') {
                                $('#' + id).css({'fill': uscanada_map_t_config[id]['dwnclr']});
                            }
                            $mtip.show().html(uscanada_map_t_config[id]['hover']);
                            $mtip.css({left: x, top: y})
                        })
                        _Textobj.on('touchend', function () {
                            $('#' + id).css({'fill': uscanada_map_t_config[id]['upclr']});
                            if (uscanada_map_t_config[id]['targt'] === '_blank') {
                                window.open(uscanada_map_t_config[id]['url']);
                            } else if (uscanada_map_t_config[id]['targt'] === '_self') {
                                window.parent.location.href = uscanada_map_t_config[id]['url'];
                            }
                            $('#tipuscanadamap-t').hide();
                        })
                    }
                }).on('touchmove', function (e) {
                    touchmoved = true;
                }).on('touchstart', function () {
                    touchmoved = false;
                });
            }
            _Textobj.attr({'cursor': 'pointer'});

            _Textobj.on('mouseenter', function () {
                $('#tipuscanadamap-t').show().html(uscanada_map_t_config[id]['hover']);
                _obj.css({'fill': uscanada_map_t_config[id]['ovrclr']})
            }).on('mouseleave', function () {
                $('#tipuscanadamap-t').hide();
                $('#' + id).css({'fill': uscanada_map_t_config[id]['upclr']});
            })
            if (uscanada_map_t_config[id]['targt'] !== 'none') {
                _Textobj.on('mousedown', function () {
                    $('#' + id).css({'fill': uscanada_map_t_config[id]['dwnclr']});
                })
            }
            _Textobj.on('mouseup', function () {
                $('#' + id).css({'fill': uscanada_map_t_config[id]['ovrclr']});
                if (uscanada_map_t_config[id]['targt'] === '_blank') {
                    window.open(uscanada_map_t_config[id]['url']);
                } else if (uscanada_map_t_config[id]['targt'] === '_self') {
                    window.parent.location.href = uscanada_map_t_config[id]['url'];
                }
            })
            _Textobj.on('mousemove', function (e) {
                let x = e.pageX + 10, y = e.pageY + 15;

                let $muscanada = $('#tipuscanadamap-t');
                let maptipw = $muscanada.outerWidth(), maptiph = $muscanada.outerHeight();

                x = (x + maptipw > $(document).scrollLeft() +
                    $(window).width()) ? x - maptipw - (20 * 2) : x
                y = (y + maptiph > $(document).scrollTop() + $(window).height()) ?
                    $(document).scrollTop() + $(window).height() - maptiph - 10 : y

                $muscanada.css({left: x, top: y})
            })
        }
    }
})(jQuery);
